=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module Shippo
  class CarrierParcelTemplatesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # List all carrier parcel templates
    # List all carrier parcel template objects.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :include 
    # @option opts [String] :carrier filter by specific carrier
    # @return [Array<CarrierParcelTemplateStruct>]
    def list_carrier_parcel_templates(opts = {})
      data, _status_code, _headers = list_carrier_parcel_templates_with_http_info(opts)
      data
    end

    # List all carrier parcel templates
    # List all carrier parcel template objects.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :include 
    # @option opts [String] :carrier filter by specific carrier
    # @return [Array<(Array<CarrierParcelTemplateStruct>, Integer, Hash)>] Array<CarrierParcelTemplateStruct> data, response status code and response headers
    def list_carrier_parcel_templates_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CarrierParcelTemplatesApi.list_carrier_parcel_templates ...'
      end
      if @api_client.config.client_side_validation && opts[:'include'] && !['all', 'user', 'enabled'].include?(opts[:'include'])
        fail ArgumentError, 'invalid value for "include", must be one of all, user, enabled'
      end
      # resource path
      local_var_path = '/parcel-templates/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'include'] = opts[:'include'] if !opts[:'include'].nil?
      query_params[:'carrier'] = opts[:'carrier'] if !opts[:'carrier'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<CarrierParcelTemplateStruct>' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CarrierParcelTemplatesApi#list_carrier_parcel_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve a carrier parcel templates
    # Fetches the parcel template information for a specific carrier parcel template, identified by the token.
    # @param carrier_parcel_template_token The unique string representation of the carrier parcel template
    # @param [Hash] opts the optional parameters
    # @return [CarrierParcelTemplateStruct]
    def get_carrier_parcel_template(carrier_parcel_template_token, opts = {})
      data, _status_code, _headers = get_carrier_parcel_template_with_http_info(carrier_parcel_template_token, opts)
      data
    end

    # Retrieve a carrier parcel templates
    # Fetches the parcel template information for a specific carrier parcel template, identified by the token.
    # @param carrier_parcel_template_token The unique string representation of the carrier parcel template
    # @param [Hash] opts the optional parameters
    # @return [Array<(CarrierParcelTemplateStruct, Integer, Hash)>] CarrierParcelTemplateStruct data, response status code and response headers
    def get_carrier_parcel_template_with_http_info(carrier_parcel_template_token, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CarrierParcelTemplatesApi.get_carrier_parcel_template ...'
      end
      # verify the required parameter 'carrier_parcel_template_token' is set
      if @api_client.config.client_side_validation && carrier_parcel_template_token.nil?
        fail ArgumentError, "Missing the required parameter 'carrier_parcel_template_token' when calling CarrierParcelTemplatesApi.get_carrier_parcel_template"
      end
      # resource path
      local_var_path = '/parcel-templates/{CarrierParcelTemplateToken}/'.sub('{' + 'CarrierParcelTemplateToken' + '}', carrier_parcel_template_token.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'CarrierParcelTemplateStruct' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CarrierParcelTemplatesApi#get_carrier_parcel_template\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
